package com.unitesk.reqcoverage.eclipse.wizards.reports;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.dialogs.DialogSettings;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;

import com.unitesk.requality.core.CoreUtils;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.core.transaction.TransactionStorage;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.core.EclipseTracker;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.eclipse.wizards.ExternalFileSelectionPage;
import com.unitesk.requality.eclipse.wizards.report.IReportWizardPage;
import com.unitesk.requality.eclipse.wizards.report.ReportWizardPagesSet;
import com.unitesk.requality.tests.CoverageStorage;
import com.unitesk.requality.tests.ICoverageSourceWizard;
import com.unitesk.requality.tests.ICoverageStorageSource;

public class CoverageWizardPages extends ReportWizardPagesSet {

  private TreeNode node;
  private CoverageSourcePage selectSource;

  @Override
  public void initPages(IWorkbench workbench, IStructuredSelection selection, TreeNode node) {
    this.node = node;
    //        try{
    //
    //        	ElementListSelectionDialog dialog = new ElementListSelectionDialog(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), new LabelProvider());
    //
    //        	dialog.setTitle("Coverage Source Selection");
    //
    //        	dialog.setMessage("Select a Source of Coverage Information");
    //
    //        	List<Object> elems = new ArrayList<Object>();
    //         	IdToName idtm = new IdToName("com.unitesk.requality.defaultsource","From File");
    //        	elems.add(idtm);
    //        	Map<String,String> map = Activator.getDefault().getCoverageSourceNames();
    //
    //        	String selnow = node.getStringAttributeValue("coverageStorageType");
    //        	IdToName temp = null;
    //        	for(String s:map.keySet()){
    //        		IdToName o = new IdToName(s, map.get(s));
    //        		elems.add(o);
    //        		if(selnow!=null && s.equals(selnow))
    //        			temp = o;
    //        	}
    //        	dialog.setMultipleSelection(false);
    //        	dialog.setElements(elems.toArray());
    //        	List sel = new ArrayList();
    //        	if(temp != null)
    //        		sel.add(temp);
    //        	else
    //        		sel.add(idtm);
    //        	dialog.setInitialElementSelections(sel);
    //        	int res = dialog.open();
    //
    //        }
    //        catch(Exception e){
    //        	e.printStackTrace();
    //        	TreeDB db = node.getTreeDB();
    //        	if(db!=null && db.getStorage() instanceof TransactionStorage)
    //        		db.rollback();
    //        }
  }

  private int it = 0;
  private Map<Integer, IReportWizardPage> pages = new HashMap<Integer, IReportWizardPage>();

  private void initPages() {
    if (!pages.containsKey(0)) pages.put(0, new CoverageSourcePage("Coverage Source Page", node));
    if (CoverageSourcePage.COVERAGE_FILE_ID.equals(
        ((CoverageSourcePage) pages.get(0)).getSelectedId())) {
      if (!(pages.get(1) instanceof NodeFileAttributePage))
        pages.put(
            1,
            new NodeFileAttributePage(
                "Coverage By File Selection", node, "coverageFilePath", new String[] {"xml"}));
    } else {

    }
  }

  @Override
  public IReportWizardPage getNextPage() {
    initPages();
    it++;
    if (it >= pages.size()) return null;
    return pages.get(it);
  }

  @Override
  public IReportWizardPage getPreviousPage() {
    initPages();
    it--;
    if (it < 0) return null;
    return pages.get(it);
  }

  @Override
  public void saveChanges() {
    // TODO Auto-generated method stub

  }
}
