package com.unitesk.reqcoverage.eclipse.wizards.reports;

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.dialogs.DialogSettings;
import org.eclipse.jface.wizard.IWizardPage;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.AttributeDefinition;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.core.EclipseTracker;
import com.unitesk.requality.eclipse.wizards.ExternalFileSelectionPage;
import com.unitesk.requality.eclipse.wizards.report.IReportWizardPage;

public class NodeFileAttributePage extends ExternalFileSelectionPage implements IReportWizardPage {

  private TreeNode node;
  private String name;

  protected NodeFileAttributePage(
      String pageName, TreeNode report, String attrName, String[] exts) {
    super(getDialogSettings(report, attrName, exts), exts);
    init(report);
    name = attrName;
    // TODO Auto-generated constructor stub
  }

  private static DialogSettings getDialogSettings(TreeNode report, String attrName, String[] exts) {
    DialogSettings ds = new DialogSettings("fileByAttribute" + attrName);
    Attribute now = report.attrs().getAttribute(attrName);
    if (now != null
        && now.getType() == AttributeType.STRING
        && now.getValue() != null)
      ds.put("filePath", now.getValue().toString());
    return ds;
  }

  @Override
  public void init(TreeNode report) {
    this.node = report;
  }

  @Override
  public TreeNode getReportNode() {
    return node;
  }

  @Override
  public void saveChanges() {
    IProject proj = EclipseTracker.getTracker().getProject(getReportNode().getTreeDB());
    String fname =
        Activator.getDefault().getProjectRelatedPath(getSelectedResource().getAbsolutePath(), proj);
    node.attrs().setConstAttribute(name, fname, AttributeDefinition.detectFlags(name));
  }
}
