package com.unitesk.reqcoverage.reqstracer;

import java.util.List;

import com.unitesk.reqcoverage.reqstracer.CoverageTree.Status;

public class Summary {
  public List<CoverageTree> nonGroupingRequiements;
  public List<CoverageTree> testPurposes;

  public int countNonGroupingRequirements() {
    int result = nonGroupingRequiements.size();
    return result;
  }

  public int countTestPurposes() {
    int result = testPurposes.size();
    return result;
  }

  public int countCoveredNonGroupingRequirements() {
    int result = nodesCount(nonGroupingRequiements, Status.COVERED);
    return result;
  }

  public int countCoveredTestPurposes() {
    int result = nodesCount(testPurposes, Status.COVERED);
    return result;
  }

  public int countUncoveredNonGroupingRequirements() {
    int result = nodesCount(nonGroupingRequiements, Status.UNCOVERED);
    return result;
  }

  public int countUncoveredTestPurposes() {
    int result = nodesCount(testPurposes, Status.UNCOVERED);
    return result;
  }

  public int countPartialNonGroupingRequirements() {
    int result = nodesCount(nonGroupingRequiements, Status.PARTIAL);
    return result;
  }

  private int nodesCount(List<CoverageTree> nodeList, Status expectedStatus) {
    int result = 0;
    for (CoverageTree node : nodeList) {
      if (node.getStatus() == expectedStatus) {
        result += 1;
      }
    }
    return result;
  }
}
