package com.unitesk.reqcoverage.tests;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.unitesk.reqcoverage.Activator;
import com.unitesk.requality.core.descriptors.TestGeneratorDescriptor;
import com.unitesk.requality.tests.ITestGeneratorsProvider;

public class CoverageTestsGenerators implements ITestGeneratorsProvider {

  @Override
  public TestGeneratorDescriptor[] getDescriptors() {
    List<TestGeneratorDescriptor> list = new ArrayList<TestGeneratorDescriptor>();
    Map<String, Map<String, String>> map = Activator.getDefault().getTestDescriptions();
    for (String s : map.keySet())
      list.add(new TestGeneratorDescriptor(s, map.get(s).get("name"), new NewTestGenerator(s)));
    return list.toArray(new TestGeneratorDescriptor[0]);
  }
}
